#!/usr/local/bin/perl

# This example does not utilize a stub file.
#

use SOAP::Lite;
import SOAP::Data qw/name value/;

# database to log in to and username and password to log in with
# fill in these values here
my $username = "";
my $password = "";
my $database = "";

my $wsdl = "http://localhost/ttsoapcgi.wsdl";
my $schema = 'http://www.w3.org/2001/XMLSchema';

my $soap = SOAP::Lite->service($wsdl)->xmlschema($schema);

# Uncomment out the following lines to see a database list first

#my $dbList = $soap->getDatabaseList();
#for my $db (@{$dbList})
#{
 #   print "$db->{name}\n";
#}

my $cookie = 0;

# log on
$cookie = $soap->DatabaseLogon($database, $username, $password);
print "\ncookie = $cookie\n";

# get the list of tables, and print menu to select from
my $tableList = $soap->getTableList($cookie);

my $count = (@{$tableList});
my $tbl;
my $tableName;
print "count = $count\n";

my $num;
for( my $i = 0; $i < $count; $i++ )
{
    $num = $i+1;
    $tbl = (@{$tableList})[$i];
    $tableName = $tbl->{name};
    print "\t$num - $tableName\n";
}

print "Choose a table from the list.\n";

my $table;
my $fieldName;

# TODO: ADD error checking for bad/invalid input
# This will get a list of drop-down fields for the selected table
my $response;
$response = <STDIN>;
chomp $response;
if ($response)
{
    $tbl =  (@{$tableList})[$response-1];
    $tableName = $tbl->{name};
    $fieldName = $soap->getDropdownFieldForTable($cookie, $tableName);
}


$count = (@{$fieldName});

# Create another menu, this one of the drop-down fields.
print "\nDropdown fields in $tableName table\n";
print "-------------------------------------\n";
my $fld;
my $fldName;

for( my $i = 0; $i < $count; $i++ )
{
    $num = $i + 1;
    $fld = (@{$fieldName})[$i];
    $fldName = $fld->{name};
    print " $num - $fldName\n";
}

print "\n\nChoose a field to add values to...\n";

# TODO: ADD error checking for bad/invalid input
$response = <STDIN>;
chomp $response;
if ($response)
{
    $fld = (@{$fieldName})[$response-1];
    $fldName = $fld->{name};
}

# List the field values in the selected drop-down
print "\nCurrent values in $fldName\n";
my $valueList = $soap->getDropdownFieldValuesForTable($cookie, $tableName, $fldName);

$count = (@{$valueList});

my $val;
my $valName;
for( my $i = 0; $i < $count; $i++ )
{
    $val = (@{$valueList})[$i];
    $valName = $val->{value};
    print " - $valName\n";
}

# log off
print "\n\n\n\n";
if( $cookie > 0 )
{
    $soap->DatabaseLogoff($cookie);
}


